/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the TemplateDefaultsMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplateDefaultsMutable{}

// TemplateDefaultsMutable struct for TemplateDefaultsMutable
type TemplateDefaultsMutable struct {
	WhatsappDefaults *WhatsAppTemplateDefaults `json:"whatsapp_defaults,omitempty"`
	Visibility *TemplateVisibility `json:"visibility,omitempty"`
}

// NewTemplateDefaultsMutable instantiates a new TemplateDefaultsMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplateDefaultsMutable() *TemplateDefaultsMutable {
	this := TemplateDefaultsMutable{}
	return &this
}

// NewTemplateDefaultsMutableWithDefaults instantiates a new TemplateDefaultsMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplateDefaultsMutableWithDefaults() *TemplateDefaultsMutable {
	this := TemplateDefaultsMutable{}
	return &this
}

// GetWhatsappDefaults returns the WhatsappDefaults field value if set, zero value otherwise.
func (o *TemplateDefaultsMutable) GetWhatsappDefaults() WhatsAppTemplateDefaults {
	if o == nil || IsNil(o.WhatsappDefaults) {
		var ret WhatsAppTemplateDefaults
		return ret
	}
	return *o.WhatsappDefaults
}

// GetWhatsappDefaultsOk returns a tuple with the WhatsappDefaults field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateDefaultsMutable) GetWhatsappDefaultsOk() (*WhatsAppTemplateDefaults, bool) {
	if o == nil || IsNil(o.WhatsappDefaults) {
		return nil, false
	}
	return o.WhatsappDefaults, true
}

// HasWhatsappDefaults returns a boolean if a field has been set.
func (o *TemplateDefaultsMutable) HasWhatsappDefaults() bool {
	if o != nil && !IsNil(o.WhatsappDefaults) {
		return true
	}

	return false
}

// SetWhatsappDefaults gets a reference to the given WhatsAppTemplateDefaults and assigns it to the WhatsappDefaults field.
func (o *TemplateDefaultsMutable) SetWhatsappDefaults(v WhatsAppTemplateDefaults) {
	o.WhatsappDefaults = &v
}

// GetVisibility returns the Visibility field value if set, zero value otherwise.
func (o *TemplateDefaultsMutable) GetVisibility() TemplateVisibility {
	if o == nil || IsNil(o.Visibility) {
		var ret TemplateVisibility
		return ret
	}
	return *o.Visibility
}

// GetVisibilityOk returns a tuple with the Visibility field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateDefaultsMutable) GetVisibilityOk() (*TemplateVisibility, bool) {
	if o == nil || IsNil(o.Visibility) {
		return nil, false
	}
	return o.Visibility, true
}

// HasVisibility returns a boolean if a field has been set.
func (o *TemplateDefaultsMutable) HasVisibility() bool {
	if o != nil && !IsNil(o.Visibility) {
		return true
	}

	return false
}

// SetVisibility gets a reference to the given TemplateVisibility and assigns it to the Visibility field.
func (o *TemplateDefaultsMutable) SetVisibility(v TemplateVisibility) {
	o.Visibility = &v
}

func (o TemplateDefaultsMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplateDefaultsMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.WhatsappDefaults) {
		toSerialize["whatsapp_defaults"] = o.WhatsappDefaults
	}
	if !IsNil(o.Visibility) {
		toSerialize["visibility"] = o.Visibility
	}
	return toSerialize, nil
}

type NullableTemplateDefaultsMutable struct {
	value *TemplateDefaultsMutable
	isSet bool
}

func (v NullableTemplateDefaultsMutable) Get() *TemplateDefaultsMutable {
	return v.value
}

func (v *NullableTemplateDefaultsMutable) Set(val *TemplateDefaultsMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplateDefaultsMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplateDefaultsMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplateDefaultsMutable(val *TemplateDefaultsMutable) *NullableTemplateDefaultsMutable {
	return &NullableTemplateDefaultsMutable{value: val, isSet: true}
}

func (v NullableTemplateDefaultsMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplateDefaultsMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


